/*
 * name AllGuiPart.pde
 * date Mon Mar 04 22:37:47 JST 2013
 * 
 * Released under the 'Buy Me a Beer' license
 * (If we ever meet, you buy me a beer)
 */

import net.triring.emuduino.*;
import net.triring.util.display.tools.*;
import ddf.minim.AudioOutput;
// Pin割り当て
// constants won't change. They're used here to 
// set pin numbers:
int         D2 =   2;  // Led:Red
int         D3 =   3;  // Led:Green
int         D4 =   4;  // Led:Blue
int         D5 =   5;  // Switch:Push
int         D6 =   6;  // Switch:Push
int         D7 =   7;  // Switch:Push
int        D10 =  10;  // Speaker:
int        D13 =  13;  // Arduino:
int         A0 =   0;  // Slider:INPUT
int         A1 =   1;  // Slider:INPUT
int         A2 =   2;  // Slider:INPUT
int        A10 =  10;  // DataReproducer
int        A11 =  11;  // DataReproducer
int        A12 =  12;  // DataReproducer
int   S0 =   0;  // Serial
int   S1 =   1;  // Serial
int  S19 =  19;  // SevenSegmentDisplay
int  S18 =  18;  // SevenSegmentDisplay
int  S17 =  17;  // Lcd1602
int  S16 =  16;  // Lcd1602
int  S15 =  15;  // Droid
int  S14 =  14;  // Droid

void setup() {
  initComponents();

  // initialize

     pinMode(D2, OUTPUT);  // Led:Red
     pinMode(D3, OUTPUT);  // Led:Green
     pinMode(D4, OUTPUT);  // Led:Blue
     pinMode(D5,  INPUT);  // Switch:Push
     pinMode(D6,  INPUT);  // Switch:Push
     pinMode(D7,  INPUT);  // Switch:Push
     pinMode(D10, OUTPUT);  // Speaker:
     pinMode(D13, OUTPUT);  // Arduino:

  // led2.setState(HIGH);
     led3.setState(HIGH);
  // led4.setState(HIGH);
     arduino13.setState(HIGH);
     disp7SEG1(0, 1);
     disp7SEG1(1, 2);
     droid3.setColor(1);
}

void loop() {
// digitalWrite(13, HIGH);    // turn the LED on (HIGH is the voltage level)
// delay(1000);               // wait for a second
// digitalWrite(13, LOW);     // turn the LED off by making the voltage LOW
// delay(1000);               // wait for a second
}

void draw() {

  loop();
}

// システムの機能を完全に停止させる禁断のメソッド
// 決して、使ってはならない。
void balse() {
  System.exit(0);
}                                            

// digital INPUT
int digitalRead(int inPin) {
    int value = 0;
    switch (inPin) {
        case 5 : value = switch5.isState(); break;
        case 6 : value = switch6.isState(); break;
        case 7 : value = switch7.isState(); break;
    }
    return value;
}
// digital OUTPUT
void digitalWrite(int outPin, int value) {
    switch (outPin) {
        case 2 : led2.setState(value); break;
        case 3 : led3.setState(value); break;
        case 4 : led4.setState(value); break;
        case 13 : arduino13.setState(value); break;
    }
}
// analog INPUT
int analogRead(int inPin) {
    int value = 0;
    switch (inPin) {
        case   0 : value = slider0.getValue(); break;
        case   1 : value = slider1.getValue(); break;
        case   2 : value = slider2.getValue(); break;
        case  10 : value = data_reproducer.getValue( 0); break;
        case  11 : value = data_reproducer.getValue( 1); break;
        case  12 : value = data_reproducer.getValue( 2); break;
    }
    return value;
}
// Speakerで使用する関数群

void tone(int pin, int frequency) {
  if (ToneFlag == frequency) return;
  ToneFlag = frequency;
  speaker10.setFrequency(frequency);
  sine.setFreq((float)frequency);
  auOut.unmute();
  auOut.sound();
}

void tone(int pin, int frequency, long duration) {
  if (ToneFlag == frequency) return;
  ToneFlag = frequency;
  sine.setFreq((float)frequency);
  auOut.unmute();
  auOut.sound();
  TimerTaskAudioStop timerTask = new TimerTaskAudioStop(); //タイマータスクインスタンス作成
  //タイマー開始
  DelayTimer.schedule(timerTask, duration);
}

void noTone() {
  ToneFlag = 0;
  speaker10.setFrequency(0);
  auOut.mute();
  auOut.noSound();
}
// Seven Segment Display
void disp7SEG1(int n, int value) {
  // n     : 7seg number  0 - 3
  // value : 0 - 15
  switch (n) {
    case  0 : ssd1[0].setValue(value); break;
    case  1 : ssd1[1].setValue(value); break;
    case  2 : ssd1[2].setValue(value); break;
    case  3 : ssd1[3].setValue(value); break;
  }
}
java.awt.Image readImage(String imgfile) {
  PImage pImage = loadImage(imgfile);
  return pImage.getImage();
}

//TimerTask内部クラス
class TimerTaskAudioStop extends java.util.TimerTask {
  public void run() {
    ToneFlag = 0;
    auOut.noSound();
    auOut.mute();
  }
}

// 指定された時間だけ停止する。単位はus
void delayMicroseconds(int t_us) {
  try {
    Thread.sleep(0, t_us * 1000);  // マイクロ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// 指定された時間だけ停止する。単位はms
void delay(long t_ms) {
  try {
    Thread.sleep(t_ms);  // ミリ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// arduino起動後の時間をus単位で返す。
long micros() {
  return (SystemStartTimeNS - System.nanoTime()) * 1000;
}

// 以下は、互換性のためだけに用意したダミー関数である。
void pinMode(int pin, int mode) {
   print("pin = " + pin + ", mode = " + mode);
}

/**
 * This method is called from within the constructor to initialize the form.
 * WARNING: Do NOT modify this code. The content of this method is always
 * regenerated by the Form Editor.
 */
// @SuppressWarnings("unchecked")
// <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
private void initComponents() {
  ToneFlag = 0;

  // digital
                      bbg  = new BlueBackground();
                      led2 = new Led(2 , "red",     4,   24);
                      led3 = new Led(3 , "green", 124,   24);
                      led4 = new Led(4 , "blue",  244,   24);
                   switch5 = new Switch(5 , "Push5",    4,  158);
                   switch6 = new Switch(6 , "Push6",  124,  158);
                   switch7 = new Switch(7 , "Push7",  244,  158);
                 speaker10 = new Speaker(10 , "speaker10",  484,  158);
                 arduino13 = new Arduino(13 , "arduino13",  670,   24, "controller_arduino_diecimila");    // 283, 254
              // arduino13 = new Arduino(13 , "arduino13",  320,    0, "controller_arduino_pro_mini_red"); // 162, 349
                   slider0 = new Slider(0 , "INPUT0",    4,  384);
                   slider1 = new Slider(1 , "INPUT1",  124,  384);
                   slider2 = new Slider(2 , "INPUT2",  244,  384);
        // data_reproducer = new DataReproducer("DataReproducer",  666,    0); // 371, 369
           data_reproducer = new DataReproducer("DataReproducer",  364,  384); // 371, 369
  
  Serial = new SerialConsole(744, 384);  // 405, 347
  nixie = new NixieTube(0, "Nixie 0", 1098, 289);

      ssd1 = new SevenSegmentDisplay[4]; // 144, 264
  for (int r = 0; r < 1;    r++) {
    for (int c = 0; c < 2; c++) {
      int i = (r * c) + c;
      String ssd_num = "SSD " + Integer.valueOf(i).toString();
      ssd1[i] = new SevenSegmentDisplay(i , ssd_num, 954 + c * 144, 24 + r * 264);
    }
  }

  lcd2 = new Lcd(2 , 364, 24, 1602);  // 304, 130
  droid3 = new Droid(3 , "Droid 3", 364, 158);
  

  minim = new ddf.minim.Minim(this);
  // get a line out from Minim, default bufferSize is 1024, default sample rate is 44100, bit depth is 16
  auOut = minim.getLineOut(ddf.minim.Minim.STEREO);
  // create a sine wave Oscillator, set to 440 Hz, at 0.5 amplitude, sample rate from line out
  sine = new ddf.minim.signals.SineWave(440, 0.5, auOut.sampleRate());
  // set the portamento speed on the oscillator to 200 milliseconds
  sine.portamento(200);

  DelayTimer = new java.util.Timer(); //タイマーインスタンス作成

  // add the oscillator to the line out
  auOut.addSignal(sine);
  auOut.noSound();  // Disables all signals currently attached to this.
  auOut.mute();
  ToneFlag = 0;

  SystemStartTimeMS = System.currentTimeMillis();  //ミリ秒で表される現在の時間を返します。
  SystemStartTimeNS = System.nanoTime(); // 利用可能でもっとも正確なシステムタイマーの現在の値をナノ秒単位で返します。
  size(320, 128);
  setLocation(0, 600);
  background(15, 115, 145);
  fill( 15, 115, 145);  rect(0, 0, 320, 128);
  fill( 30, 160, 145);  textSize(60); text(TITLE , 24, 68);
  fill( 45, 192, 145);  textSize(60); text(TITLE , 22, 66);
  fill(255, 255, 255);  textSize(60); text(TITLE , 20, 64);
  fill(255, 255, 255);  textSize(18); text("Ver. " + Arduino.getVersion(), 120, 108);
  setLocation(8, 600);
}// </editor-fold>//GEN-END:initComponents

// 変数の宣言部
// Variables declaration - do not modify//GEN-BEGIN:variables

private String TITLE   = "Emuduino";
private String VERSION = "0.49"; // Arduino.javaで使用するプロパティファイル中のバージョンを参照する。

private long SystemStartTimeMS;
private long SystemStartTimeNS;

private static final int HIGH   = 0x1;
private static final int LOW    = 0x0;
private static final int INPUT  = 0x0;
private static final int OUTPUT = 0x1;

private int ToneFlag = 0;  // 0の場合は停止状態。再生中は，その周波数を保持

private java.util.Timer            DelayTimer;
private java.util.TimerTask        TimerTaskAudioStop;
private ddf.minim.Minim            minim; // http://code.compartmental.net/minim/javadoc/
private ddf.minim.AudioOutput      auOut;
private ddf.minim.signals.SineWave sine;

private BlueBackground bbg;
private Led led2;
private Led led3;
private Led led4;
private Switch switch5;
private Switch switch6;
private Switch switch7;
private Speaker speaker10;
private Arduino arduino13;
private Slider slider0;
private Slider slider1;
private Slider slider2;
private DataReproducer data_reproducer;
private SerialConsole Serial;
private SevenSegmentDisplay[] ssd1;
private Lcd lcd2;
private Droid droid3;
private NixieTube nixie;


// End of variables declaration//GEN-END:variables


