/*
 * name Button2LED.pde
 * date Tue Feb 05 17:05:59 JST 2013
 * 
 * Released under the 'Buy Me a Beer' license
 * (If we ever meet, you buy me a beer)
 */

import net.triring.emuduino.*;
import ddf.minim.AudioOutput;
// Pin割り当て
// constants won't change. They're used here to 
// set pin numbers:
int   ledRedPin    =   2;  // Led:Red
int   ledYellowPin =   3;  // Led:Yellow
int   ledGreenPin  =   4;  // Led:Green
int   buttonPin5   =   5;  // Switch:Push
int   buttonPin6   =   6;  // Switch:Push
int   buttonPin7   =   7;  // Switch:Push

// variables will change:
int buttonState = 0;         // variable for reading the pushbutton status
                                          
void setup() {
   // Switch が押されると LEDを点灯します。 
   // Switch 5 --> LED 2 Red
   // Switch 6 --> LED 3 Yellow
   // Switch 7 --> LED 4 Green
  initComponents();
  // initialize the pushbutton pin as an input:
     pinMode(buttonPin5, INPUT);  // Switch:Push
     pinMode(buttonPin6, INPUT);  // Switch:Push
     pinMode(buttonPin7, INPUT);  // Switch:Push

  // initialize the LED pin as an output:
     pinMode(ledRedPin,    OUTPUT);  // Led:Red
     pinMode(ledYellowPin, OUTPUT);  // Led:Yellow
     pinMode(ledGreenPin,  OUTPUT);  // Led:Green
}

void loop() {
  // read the state of the pushbutton value:
  buttonState = digitalRead(buttonPin5);
  if (buttonState == HIGH)  digitalWrite(ledRedPin, HIGH);     // turn LED on:    
  else                      digitalWrite(ledRedPin, LOW);      // turn LED off:

  buttonState = digitalRead(buttonPin6);
  if (buttonState == HIGH)  digitalWrite(ledYellowPin, HIGH);  // turn LED on:    
  else                      digitalWrite(ledYellowPin, LOW);   // turn LED off:

  buttonState = digitalRead(buttonPin7);
  if (buttonState == HIGH)  digitalWrite(ledGreenPin, HIGH);   // turn LED on:    
  else                      digitalWrite(ledGreenPin, LOW);    // turn LED off:
}

void draw() {
  loop();
}

// システムの機能を完全に停止させる禁断のバルスメソッド
// 決して、使ってはならない。
void Balse() {
  System.exit(0);
}

// digital INPUT
int digitalRead(int inPin) {
    int value = 0;
    switch (inPin) {
        case 5 : value = switch5.isState(); break;
        case 6 : value = switch6.isState(); break;
        case 7 : value = switch7.isState(); break;
    }
    return value;
}
// digital OUTPUT
void digitalWrite(int outPin, int value) {
    switch (outPin) {
        case 2 : led2.setState(value); break;
        case 3 : led3.setState(value); break;
        case 4 : led4.setState(value); break;
    }
}
java.awt.Image readImage(String imgfile) {
  PImage pImage = loadImage(imgfile);
  return pImage.getImage();
}

//TimerTask内部クラス
class TimerTaskAudioStop extends java.util.TimerTask {
  public void run() {
    ToneFlag = 0;
    auOut.noSound();
    auOut.mute();
  }
}

// 指定された時間だけ停止する。単位はus
void delayMicroseconds(int t_us) {
  try {
    Thread.sleep(0, t_us * 1000);  // マイクロ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// 指定された時間だけ停止する。単位はms
void delay(long t_ms) {
  try {
    Thread.sleep(t_ms);  // ミリ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// arduino起動後の時間をus単位で返す。
long micros() {
  return (SystemStartTimeNS - System.nanoTime()) * 1000;
}

// 以下は、互換性のためだけに用意したダミー関数である。
void pinMode(int pin, int mode) {
   print("pin = " + pin + ", mode = " + mode);
}

/**
 * This method is called from within the constructor to initialize the form.
 * WARNING: Do NOT modify this code. The content of this method is always
 * regenerated by the Form Editor.
 */
// @SuppressWarnings("unchecked")
// <editor-fold defaultstate="collapsfsed" desc="Generated Code">//GEN-BEGIN:initComponents
private void initComponents() {
  ToneFlag = 0;

  // digital
                      led2 = new Led(2 ,    "red",      0,    0);
                      led3 = new Led(3 ,    "yellow", 120,    0);
                      led4 = new Led(4 ,    "green",  240,    0);
                   switch5 = new Switch(5 , "Push5",    0,  128);
                   switch6 = new Switch(6 , "Push6",  120,  128);
                   switch7 = new Switch(7 , "Push7",  240,  128);
  

  minim = new ddf.minim.Minim(this);
  // get a line out from Minim, default bufferSize is 1024, default sample rate is 44100, bit depth is 16
  auOut = minim.getLineOut(ddf.minim.Minim.STEREO);
  // create a sine wave Oscillator, set to 440 Hz, at 0.5 amplitude, sample rate from line out
  sine = new ddf.minim.signals.SineWave(440, 0.5, auOut.sampleRate());
  // set the portamento speed on the oscillator to 200 milliseconds
  sine.portamento(200);

  DelayTimer = new java.util.Timer(); //タイマーインスタンス作成

  // add the oscillator to the line out
  auOut.addSignal(sine);
  auOut.noSound();  // Disables all signals currently attached to this.
  auOut.mute();
  ToneFlag = 0;

  SystemStartTimeMS = System.currentTimeMillis();  //ミリ秒で表される現在の時間を返します。
  SystemStartTimeNS = System.nanoTime(); // 利用可能でもっとも正確なシステムタイマーの現在の値をナノ秒単位で返します。
  size(320, 128);
  setLocation(0, 600);
  background(15, 115, 145);
  fill( 15, 115, 145);  rect(0, 0, 320, 128);
  fill( 30, 160, 145);  textSize(60); text(TITLE , 24, 68);
  fill( 45, 192, 145);  textSize(60); text(TITLE , 22, 66);
  fill(255, 255, 255);  textSize(60); text(TITLE , 20, 64);
  fill(255, 255, 255);  textSize(18); text("Ver. " + Arduino.getVersion(), 120, 108);
  setLocation(0, 600);
}// </editor-fold>//GEN-END:initComponents

// 変数の宣言部
// Variables declaration - do not modify//GEN-BEGIN:variables

private String TITLE   = "Emuduino";
private String VERSION = "0.49"; // Arduino.javaで使用するプロパティファイル中のバージョンを参照する。

private long SystemStartTimeMS;
private long SystemStartTimeNS;

private static final int HIGH   = 0x1;
private static final int LOW    = 0x0;
private static final int INPUT  = 0x0;
private static final int OUTPUT = 0x1;

// private static final int A0     = 0x0;
// private static final int A1     = 0x1;
// private static final int A2     = 0x2;
// private static final int A3     = 0x3;
// private static final int A4     = 0x4;
// private static final int A5     = 0x5;
// private static final int A6     = 0x6;
// private static final int A7     = 0x7;
// private static final int A8     = 0x8;
// private static final int A9     = 0x9;

private int ToneFlag = 0;  // 0の場合は停止状態。再生中は，その周波数を保持

private java.util.Timer            DelayTimer;
private java.util.TimerTask        TimerTaskAudioStop;
private ddf.minim.Minim            minim; // http://code.compartmental.net/minim/javadoc/
private ddf.minim.AudioOutput      auOut;
private ddf.minim.signals.SineWave sine;

private Led led2;
private Led led3;
private Led led4;
private Switch switch5;
private Switch switch6;
private Switch switch7;


// End of variables declaration//GEN-END:variables


