/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package net.triring.emuduino;

/**
 *
 * @author miwa
 */
public class SerialConfigurationPanel extends javax.swing.JPanel {
    int RX_PinNo = 0;
    int TX_PinNo = 1;

    public int getRX_PinNo() {
        return RX_PinNo;
    }

    public int getTX_PinNo() {
        return TX_PinNo;
    }

    // クラスを使用するかどうかのチェック
    public boolean isSelected() {
        return isUseCheckBox.isSelected();
    }
    
    // 先頭部のPin番号割付
    public String getRX_PinAllocation() {
        return String.format("int %4s = %3d;  // %s", RX_PinNameTextField.getText(), RX_PinNo, getTypeComboBox_SelectedItem());    
    }

    public String getTX_PinAllocation() {
        return String.format("int %4s = %3d;  // %s", TX_PinNameTextField.getText(), TX_PinNo, getTypeComboBox_SelectedItem());
    }

    
    public String getTypeComboBox_SelectedItem() {
         return TypeComboBox.getSelectedItem().toString();
    }

    // Constructor
    public String getConstructor(int n) {
        String result = "";
        String[] str = TypeComboBox.getSelectedItem().toString().split(":");
        String deviceName = str[0];
        String option     = OptionTextField.getText().trim();
        String x = xSpinner.getValue().toString().trim();
        String y = ySpinner.getValue().toString().trim();
        if (deviceName.equals("Serial")) {
            result = String.format("Serial = new SerialConsole(%s, %s);", x, y);
        } else if (deviceName.equals("SevenSegmentDisplay")) {
            int column = 1;
            int row    = 1;
            String[] opt = option.split(",");
            switch (opt.length) {
                    case  0 :
                    case  1 : column = Integer.parseInt(opt[0].trim());
                              row    = 1;
                              break;
                    case  2 : column = Integer.parseInt(opt[0].trim());
                              row    = Integer.parseInt(opt[1].trim());
                              break;                   
            }

            java.lang.StringBuffer sb = new java.lang.StringBuffer();
            sb.append(String.format("  ssd%d = new SevenSegmentDisplay[%d];\n", n, column * row));
            sb.append(String.format("  for (int r = 0; r < %d;    r++) {\n",row));
            sb.append(String.format("    for (int c = 0; c < %d; c++) {\n",column));
            sb.append(              "      int i = (r * c) + c;\n");
            sb.append(              "      String ssd_num = \"SSD \" + Integer.valueOf(i).toString();\n");
            sb.append(String.format("      ssd%d[i] = new SevenSegmentDisplay(i , ssd_num, %s + c * 144, %s + r * 264);\n", n, x, y));
            sb.append(              "    }\n");
            sb.append(              "  }\n");
            /*
             * w144 x h264
             * 7seg1行に8個,3行分で24個
             */
            result = sb.toString(); 
        } else if (deviceName.equals("NixieTube")) {
            int column = 1;
            int row    = 1;
            String[] opt = option.split(",");
            switch (opt.length) {
                    case  0 :
                    case  1 : column = Integer.parseInt(opt[0].trim());
                              row    = 1;
                              break;
                    case  2 : column = Integer.parseInt(opt[0].trim());
                              row    = Integer.parseInt(opt[1].trim());
                              break;                   
            }
            
            java.lang.StringBuffer sb = new java.lang.StringBuffer();
            sb.append(String.format("  nixie%d = new NixieTube[%d];\n", n, column * row));
            sb.append(String.format("  for (int r = 0; r < %d;   r++) {\n",row));
            sb.append(String.format("    for (int c = 0; c < %d; c++) {\n",column));
            sb.append(              "      int i = (r * c) + c;\n");
            sb.append(              "      String nixie_num = \"Nixie \" + Integer.valueOf(i).toString();\n");
            sb.append(String.format("      nixie%d[i] = new NixieTube(i , nixie_num, %s + c * 168, %s + r * 460);\n", n, x, y));
            sb.append(              "    }\n");
            sb.append(              "  }\n");
            /*
             * w168 x h460
             * 7seg1行に6個,2行分で12個
             */
            result = sb.toString();        
        } else if (deviceName.equals("Lcd0802")) {
            result = String.format("lcd%d = new Lcd(%d , %s, %s,  802);", n, n, x, y);
        } else if (deviceName.equals("Lcd1602")) {
            result = String.format("lcd%d = new Lcd(%d , %s, %s, 1602);", n, n, x, y);
        } else if (deviceName.equals("Lcd1608")) {
            result = String.format("lcd%d = new Lcd(%d , %s, %s, 1608);", n, n, x, y);
        } else if (deviceName.equals("Lcd2004")) {
            result = String.format("lcd%d = new Lcd(%d , %s, %s, 2004);", n, n, x, y);
        } else if (deviceName.equals("Duke")) {
            result = String.format("duke%d = new Duke(%d , \"Duke %d\", %s, %s);", n, n, n, x, y);
        } else if (deviceName.equals("Droid")) {
            result = String.format("droid%d = new Droid(%d , \"Droid %d\", %s, %s);", n, n, n, x, y);
        }
        return result;
    }

    // クラス変数の宣言
    public String getVariablesDeclaration(int n) {
        String[] str = TypeComboBox.getSelectedItem().toString().split(":");
        String deviceName = str[0];
        return new String("private  net.triring.emuduino." + deviceName + " " + deviceName.toLowerCase() + n +";");
    }

    public String getDeviceName() {
        String[] str = getTypeComboBox_SelectedItem().split(":");
        String deviceName = str[0];
        return deviceName;
    }

    public String getDeviceAttribute1() {
        String[] str = getTypeComboBox_SelectedItem().split(":");
        String deviceName = "";
        if (str.length > 1) {
           deviceName = str[1];
        }
        return deviceName;
    }

    public String getOption() {
        return OptionTextField.getText().trim();
    }

    public String getDeviceAttribute2() {
        String[] str = getTypeComboBox_SelectedItem().split(":");
        String deviceName = "";
        if (str.length > 2) {
           deviceName = str[2];
        }
        return deviceName;
    }

    public void setRXPinNo(int RX_PinNo) {
        this.RX_PinNo = RX_PinNo;
    }

    public void setTXPinNo(int TX_PinNo) {
        this.TX_PinNo = TX_PinNo;
    }

    public String getPinName() {
        return PinName;
    }

    public void setPinName(String PinName) {
        this.PinName = PinName;
    }

    public String getTypeData() {
        return TypeData;
    }

    public void setTypeData(String TypeData) {
        this.TypeData = TypeData;
    }

    public void setOptionData(String OptionData) {
        this.OptionData = OptionData;
    }

    public int getCoordX() {
        return coordX;
    }

    public void setCoordX(int coordX) {
        this.coordX = coordX;
    }

    public int getCoordY() {
        return coordY;
    }

    public void setCoordY(int coordY) {
        this.coordY = coordY;
    }
    String PinName;
    String TypeData;
    String OptionData;
    String TypeList[];
    int coordX = 0;
    int coordY = 0;

    /**
     * Creates new form ConfigurationPanel
     */
    public SerialConfigurationPanel(int RX_PinNo,int TX_PinNo, String PinName, String TypeData, String OptionData, int coordX, int coordY) {
        this.RX_PinNo = RX_PinNo;
        this.TX_PinNo = TX_PinNo;
        this.PinName = PinName;
        this.TypeData = TypeData;
        this.OptionData = OptionData;
        initComponents();
        RX_PinNameTextField.setText(PinName + RX_PinNo);
        TX_PinNameTextField.setText(PinName + TX_PinNo);
        TypeList = TypeData.split(",");
        this.coordX = coordX; 
        this.coordY = coordY;
        for (int i = 0; i < TypeList.length; i++) {
            TypeComboBox.addItem((Object)TypeList[i].trim()); 
        }
        xSpinner.setValue(new Integer(coordX));
        ySpinner.setValue(new Integer(coordY));
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        isUseCheckBox = new javax.swing.JCheckBox();
        itemPanel = new javax.swing.JPanel();
        PinNamePanel = new javax.swing.JPanel();
        RX_PinNameTextField = new javax.swing.JTextField();
        TX_PinNameTextField = new javax.swing.JTextField();
        Type_Option_Panel = new javax.swing.JPanel();
        TypeComboBox = new javax.swing.JComboBox();
        OptionTextField = new javax.swing.JTextField();
        coordPanel = new javax.swing.JPanel();
        xPanel = new javax.swing.JPanel();
        xLabel = new javax.swing.JLabel();
        xSpinner = new javax.swing.JSpinner();
        yLabel = new javax.swing.JLabel();
        ySpinner = new javax.swing.JSpinner();

        setLayout(new java.awt.BorderLayout());
        add(isUseCheckBox, java.awt.BorderLayout.WEST);

        PinNamePanel.setLayout(new java.awt.BorderLayout());

        RX_PinNameTextField.setText("RXPinName");
        PinNamePanel.add(RX_PinNameTextField, java.awt.BorderLayout.NORTH);

        TX_PinNameTextField.setText("TXPinName");
        PinNamePanel.add(TX_PinNameTextField, java.awt.BorderLayout.SOUTH);

        itemPanel.add(PinNamePanel);

        Type_Option_Panel.setLayout(new java.awt.BorderLayout());
        Type_Option_Panel.add(TypeComboBox, java.awt.BorderLayout.NORTH);

        OptionTextField.setText("Option");
        Type_Option_Panel.add(OptionTextField, java.awt.BorderLayout.SOUTH);

        itemPanel.add(Type_Option_Panel);

        add(itemPanel, java.awt.BorderLayout.CENTER);

        coordPanel.setLayout(new java.awt.GridLayout(1, 0));

        xLabel.setText("X");
        xPanel.add(xLabel);

        xSpinner.setModel(new javax.swing.SpinnerNumberModel(0, 0, 2048, 16));
        xPanel.add(xSpinner);

        yLabel.setText("Y");
        xPanel.add(yLabel);

        ySpinner.setModel(new javax.swing.SpinnerNumberModel(0, 0, 2048, 8));
        xPanel.add(ySpinner);

        coordPanel.add(xPanel);

        add(coordPanel, java.awt.BorderLayout.EAST);
    }// </editor-fold>//GEN-END:initComponents

    private void OptionTextFieldActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_OptionTextFieldActionPerformed
       // TODO add your handling code here:
    }//GEN-LAST:event_OptionTextFieldActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextField OptionTextField;
    private javax.swing.JPanel PinNamePanel;
    private javax.swing.JTextField RX_PinNameTextField;
    private javax.swing.JTextField TX_PinNameTextField;
    private javax.swing.JComboBox TypeComboBox;
    private javax.swing.JPanel Type_Option_Panel;
    private javax.swing.JPanel coordPanel;
    private javax.swing.JCheckBox isUseCheckBox;
    private javax.swing.JPanel itemPanel;
    private javax.swing.JLabel xLabel;
    private javax.swing.JPanel xPanel;
    private javax.swing.JSpinner xSpinner;
    private javax.swing.JLabel yLabel;
    private javax.swing.JSpinner ySpinner;
    // End of variables declaration//GEN-END:variables
}
