package net.triring.emuduino;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author miwa
 */
 
import java.lang.StringBuffer;
import java.awt.Font;
public class SerialConsole extends javax.swing.JFrame {
  private static java.lang.StringBuffer DataBuffer;
  int BaudRate = 9600;

  /**
   * Creates new form SerialConsole
   */
  public SerialConsole() {
    initComponents();
    pack();
    this.setVisible(true);
  }

  public SerialConsole(int x, int y) {
    initComponents();
    // receiveTextAreaに等幅フォントを設定する。
    // この設定をしないと、文字の縦横がそろわず見苦しい。
    java.awt.Font font     = receiveTextArea.getFont();
    int fontsize = font.getSize();
    receiveTextArea.setFont(new java.awt.Font("Monospaced", java.awt.Font.PLAIN, fontsize ));

    pack();
    this.setVisible(true);
    this.setLocation(x, y);
  }

  // 受信バッファをクリアします。Serial.read()やSerial.available()が返すデータは、Serial.flush()を実行したあとのものになります。 
  public void flush() {
    DataBuffer.delete(0, DataBuffer.length());
  } 

  public int println(String data) {
    int len = data.length();
    receiveTextArea.append(data + "\n");
    return len;
  }

  public int print(String data) {
    int len = data.length();
    receiveTextArea.append(data);
    return len;
  }

  public int print(int data) {
    String value = Integer.toString(data);
    receiveTextArea.append(value);
    return value.length();
  }

  public int println(int data) {
  String value = Integer.toString(data);
    receiveTextArea.append(value + "\n");
    return value.length();
  }

  public int print(long data) {
    String value = Long.toString(data);
    receiveTextArea.append(value);
    return value.length();
  }

  public int println(long data) {
  String value = Long.toString(data);
    receiveTextArea.append(value + "\n");
    return value.length();
  }

  public int print(float data) {
    String value = Float.toString(data);
    receiveTextArea.append(value);
    return value.length();
  }

  public int println(float data) {
  String value = Float.toString(data);
    receiveTextArea.append(value + "\n");
    return value.length();
  }

  public int print(double data) {
    String value = Double.toString(data);
    receiveTextArea.append(value);
    return value.length();
  }

  public int println(double data) {
  String value = Double.toString(data);
    receiveTextArea.append(value + "\n");
    return value.length();
  }
  
  
  
  
  // シリアルポートに何バイトのデータが到着しているかを返します。バッファには128バイトまで保持できます。 
  public int available() {
    return DataBuffer.length();
  }

  // シリアルポートに何バイトのデータが到着しているかを返します。バッファには128バイトまで保持できます。 
  // 読み込み可能なデータの最初の1バイトを返します。-1の場合は、データが存在しません (int) 
  public byte read() {
    if (0 == DataBuffer.length()) return -1;
    byte b = (byte)DataBuffer.charAt(0); // 指定されたインデックス位置にある char 値を返します。先頭の文字を取り出す。

    String str = DataBuffer.substring(1, DataBuffer.length()); // 2文字目以降を取り出す。
    DataBuffer.delete(0, DataBuffer.length());
    DataBuffer.append(str);
 // println(DataBuffer.toString());
    return b;
  }

  // 受信データを1バイト読み込みますが、バッファ中の読み取り位置は変更しません。つまり、peek()は同じ文字を繰り返し読み取ります。。 
  // 読み込み可能なデータの最初の1バイトを返します。-1の場合は、データが存在しません (int) 
  public byte peek() {
    if (0 == DataBuffer.length()) return -1;
    byte b = (byte)DataBuffer.charAt(0); // 指定されたインデックス位置にある char 値を返します。先頭の文字を取り出す。
    return b;
  }
  
  // 設定した通信速度でポートを開く。

  public void begin(int BaudRate) {
   setBaudRate(BaudRate);
   return;
  }

  public int getBaudRate() {
    return BaudRate;
  }

  public void setBaudRate(int BaudRate) {
    this.BaudRate = BaudRate;
  }

  public void setSendText(String text) {
      sendTextField.setText(text);
  }

  /**
   * This method is called from within the constructor to initialize the form.
   * WARNING: Do NOT modify this code. The content of this method is always
   * regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
      DataBuffer = new java.lang.StringBuffer();

      basePanel = new javax.swing.JPanel();
      inputPanel = new javax.swing.JPanel();
      sendTextField = new javax.swing.JTextField();
      sendButton = new javax.swing.JButton();
      outputPanel = new javax.swing.JPanel();
      receiveScrollPane = new javax.swing.JScrollPane();
      receiveTextArea = new javax.swing.JTextArea();
      settingPanel = new javax.swing.JPanel();
      clearButton = new javax.swing.JButton();

      setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
      setTitle("Serial console");

      basePanel.setLayout(new java.awt.BorderLayout());

      inputPanel.setLayout(new java.awt.BorderLayout());

      sendTextField.setColumns(30);
      inputPanel.add(sendTextField, java.awt.BorderLayout.CENTER);

   // sendButton.setFont(new java.awt.Font("MS UI Gothic", 0, 14)); // NOI18N
   /*
   sendButton.setFont(java.awt.Font.getFont(java.awt.font.FACE_MONOSPACE     |
                             java.awt.Font.SIZE_MEDIUM |
                             java.awt.Font.STYLE_PLAIN));
    */
   // sendButton.setText("送信");
      sendButton.setText("Send");
      sendButton.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(java.awt.event.ActionEvent evt) {
          sendButtonActionPerformed(evt);
        }
      }
      );
      inputPanel.add(sendButton, java.awt.BorderLayout.EAST);

      basePanel.add(inputPanel, java.awt.BorderLayout.NORTH);

      outputPanel.setLayout(new java.awt.BorderLayout());

      receiveTextArea.setEditable(false);
      receiveTextArea.setColumns(40);
   // receiveTextArea.setFont(new java.awt.Font("MS UI Gothic", 0, 14)); // NOI18N
      receiveTextArea.setRows(15);
      receiveTextArea.setTabSize(4);
      receiveScrollPane.setViewportView(receiveTextArea);

      outputPanel.add(receiveScrollPane, java.awt.BorderLayout.CENTER);

      basePanel.add(outputPanel, java.awt.BorderLayout.CENTER);

   // clearButton.setText("消去");
      clearButton.setText("Clear");
      clearButton.addActionListener(new java.awt.event.ActionListener() {
        public void actionPerformed(java.awt.event.ActionEvent evt) {
          clearButtonActionPerformed(evt);
        }
      }
      );
      settingPanel.add(clearButton);

      basePanel.add(settingPanel, java.awt.BorderLayout.SOUTH);

      getContentPane().add(basePanel, java.awt.BorderLayout.CENTER);

      pack();
    }// </editor-fold>//GEN-END:initComponents

  private void sendButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_sendButtonActionPerformed
    String str = sendTextField.getText().trim();
    DataBuffer.append(str);
    sendTextField.setText("");
    // receiveTextArea.append(str + "\n");
  }//GEN-LAST:event_sendButtonActionPerformed

  private void clearButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_clearButtonActionPerformed
    receiveTextArea.setText("");
    flush();
  }//GEN-LAST:event_clearButtonActionPerformed

  /**
   * @param args the command line arguments
   */
  public static void main(String args[]) {
    /* Set the Nimbus look and feel */
    //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
    /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
     * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
     */
    try {
      for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
        if ("Nimbus".equals(info.getName())) {
          javax.swing.UIManager.setLookAndFeel(info.getClassName());
          break;
        }
      }
    } 
    catch (ClassNotFoundException ex) {
      java.util.logging.Logger.getLogger(SerialConsole.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
    } 
    catch (InstantiationException ex) {
      java.util.logging.Logger.getLogger(SerialConsole.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
    } 
    catch (IllegalAccessException ex) {
      java.util.logging.Logger.getLogger(SerialConsole.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
    } 
    catch (javax.swing.UnsupportedLookAndFeelException ex) {
      java.util.logging.Logger.getLogger(SerialConsole.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
    }
    //</editor-fold>

    /* Create and display the form */
    java.awt.EventQueue.invokeLater(new Runnable() {
      public void run() {
        new SerialConsole().setVisible(true);
      }
    }
    );
  }
  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JPanel basePanel;
  private javax.swing.JButton clearButton;
  private javax.swing.JPanel inputPanel;
  private javax.swing.JPanel outputPanel;
  private javax.swing.JScrollPane receiveScrollPane;
  private javax.swing.JTextArea receiveTextArea;
  private javax.swing.JButton sendButton;
  private javax.swing.JTextField sendTextField;
  private javax.swing.JPanel settingPanel;
  // End of variables declaration//GEN-END:variables
}

